struct GbufferData
{
    int maskID;
    int materialID;
	float ao;
    vec2 Imcoord;
    
    vec3 Normal;
	vec4 Albedo;
};

vec2 Encode322(in vec3 normal)
{
	float p = sqrt(normal.z * 8.0 + 8.0);
	return vec2(normal.xy / p + 0.5);
}

vec3 Decode223(in vec2 enc)
{
	vec2 fenc = enc * 4.0 - 2.0;
	float f = dot(fenc, fenc);
	float g = sqrt(1.0 - f / 4.0);
	vec3 normal;
	normal.xy = fenc * g;
	normal.z = 1.0 - f / 2.0;
	return normal;
}


float Encode221(vec2 v)
{
	float data;
	v = clamp(v, 0.0, 255.0 / 256.0);
	v = floor(v * 255.0);

	data = v.x * 256.0 + v.y;
	data /= 65535.0;

	return data;
}

vec2 Decode122(float value)
{
	vec2 data;

	value *= 65535.0;

	data.x = floor(value / 256.0);
	data.y = mod(value, 256.0);

	data /= 255.0;

	return data;
}

void PackGbufferData(out vec4 buf0, out vec4 buf1, out vec4 buf2, in GbufferData data)
{
	buf0 = data.Albedo;
	buf0.xyz = pow(buf0.xyz, vec3(2.2));
	// buf1 = vec4(float(data.maskID), Encode322(data.Normal), 1.0);
	// buf2 = vec4(Encode221(data.Imcoord), data.ao, float(data.materialID), 1.0);
	buf1 = vec4(Encode221(data.Imcoord), Encode322(data.Normal), 1.0);
	buf2 = vec4(float(data.maskID) / 255.0, float(data.materialID) / 255.0, data.ao, 1.0);
}

void ReadGbufferData(in vec4 pack0, in vec4 pack1, in vec4 pack2, out GbufferData data)
{
	data.Albedo = pack0;
	data.Imcoord = Decode122(pack1.x);
	data.maskID = int(pack2.x * 255.0 + 0.0001);
	data.materialID = int(pack2.y * 255.0 + 0.0001);
	data.Normal = Decode223(pack1.yz);
	data.ao = pack2.z;
}