#define SSR
#define SSRBiscard
#define SSRBiscardTimes 3//[3 4 5 6 7 8 9 10 11 12]
#define SSRTracTimes 15//[12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32]

float ExpToLinearDepth(in float depth)
{
    return (2.0 * near) / (far + near - depth * (far - near));
}

vec3 RayTracTexcoord(in vec3 start, vec3 dir, in float dither)
{
    vec3 test = start;
    dir *= 0.6 - dither * 0.325;
    vec3 result;
    for(int i = 0;i < SSRTracTimes;i++)
    {
        vec3 tracStep = dir * pow(float(i + 1), 1.5 + dither * 0.2);
        test += tracStep;
        vec3 pos = View2Proj(test);
        if(abs(pos.x) > 1 || abs(pos.y) > 1 || abs(pos.z) > 1)
            break;
        pos = pos * 0.5 + 0.5;
        if(ExpToLinearDepth(pos.z) > ExpToLinearDepth(texture(depthtex0, pos.xy).x + 0.0001))
        {
            #ifdef SSRBiscard
            for(int j = 0;j < SSRBiscardTimes;j++)
            {
                tracStep *= 0.5;
                test += tracStep * sign(ExpToLinearDepth(texture(depthtex0, pos.xy).x) - ExpToLinearDepth(pos.z));
                pos = View2Proj(test) * 0.5 + 0.5;
            }
            #endif
            result = vec3(pos.xy, float(int(texture(colortex2, pos.xy).x * 255.0 + 0.0001) == 1));
            break;
        }
    }
    return result;
}