#define VOLUME_RAY
#define VolumeRayMaxSteps 8//[5 6 7 8 9 10 11 12 13 14 15 16 18 24 32]
#define VolumeRayDistance 64.0//[8.0 16.0 24.0 32.0 48.0 56.0 64.0 72.0 80.0]
#define VolumeRayTotalStrength 1.0//[0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0 2.1 2.2 2.3 2.4 2.5 2.6 2.7 2.8 2.9]

#ifdef VOLUME_RAY
float VolumeRayRender(vec3 shadowDir, in float dist, in float dither, in bool sky)
{
    float visiable = 1.0 - min(distance(shadowDir, worldSunVec * sign(worldSunVec.y)) * 0.588235, 1.0) + max(-shadowDir.y, 0.0) * 0.35;
    visiable = pow8(max(visiable, 0.0));
    visiable *= min(dot(shadowVec, upVec) * 5.0, 1.0);
    if(visiable > 0.0 && !sky)
    {
        float stepLen = VolumeRayDistance / VolumeRayMaxSteps;
        float len = stepLen * dither;
        int steps = min(int((dist - len) / stepLen + 0.0001), VolumeRayMaxSteps);

        shadowDir = shadowMat3 * shadowDir;

        vec3 testpoint = len * shadowDir + shadowModelView[3].xyz;
        vec3 teststep = shadowDir * stepLen;

        float sumResult = 0.0;

        for(int i = 0;i < steps;i++)
        {
            testpoint += teststep;
            sumResult += textureLod(shadowtex1, Shadow2ShadowProj(testpoint), 1.0) * stepLen;
        }
        return min(sumResult * 0.010625, 2.0) * visiable;
    }else{
        return visiable * 2.0;
    }
}
#endif