#version 460 core

layout(location = 0) in vec4 TEXCOORD;

uniform float flag_day;
uniform float flag_night;
uniform float flag_sunset;
uniform float rainStrength;
uniform float rainday;
uniform float rainnight;
uniform vec3 sunVec;
uniform vec3 shadowVec;
uniform mat4 gbufferModelViewInverse;

out vec2 Texcoord;

flat out vec3 worldSunVec;
flat out vec3 worldLightVec;

void main()
{
    gl_Position = vec4(TEXCOORD.xy * 2.0 - 1.0, 0.0, 1.0);
    Texcoord = TEXCOORD.xy;
    
    mat3 viewInverse = mat3(gbufferModelViewInverse);
    worldSunVec = viewInverse * sunVec;
    worldLightVec = viewInverse * shadowVec;
}