#version 460 compatibility

layout(location = 0) out vec4 texBuffer0;
layout(location = 1) out vec4 texBuffer1;
layout(location = 2) out vec4 texBuffer2;

uniform sampler2D tex;

#ifdef MC_NORMAL_MAP
    uniform sampler2D normals;
#endif

#ifdef MC_SPECULAR_MAP
    uniform sampler2D specular;
#endif

#if MC_VERSION >= 11700
    uniform float alphaTestRef;
#endif

flat in float matID;
in float ao;
in vec2 Texcoord;
in vec2 Imcoord;
in vec3 vColor;
flat in vec3 vTangent;
flat in vec3 vBitangent;
flat in vec3 vNormal;

#include "/HmwsLib/PackDatas.glsl"

void main()
{
    GbufferData buff;
    buff.Albedo = texture(tex, Texcoord);
    buff.Albedo.rgb *= vColor;
    #if MC_VERSION >= 11700
        if(buff.Albedo.a < alphaTestRef)
            discard;
    #endif
    
    buff.maskID = 1;
    buff.materialID = int(matID + 0.001);
    buff.ao = pow(ao, 2.2);
    buff.Normal = vNormal;
    
    buff.Imcoord = Imcoord;
    
   
    PackGbufferData(texBuffer0, texBuffer1, texBuffer2, buff);
}
/* DRAWBUFFERS:012 */