#version 460 compatibility

attribute vec4 mc_midTexCoord;
attribute vec4 at_tangent;
attribute vec4 mc_Entity;

#include "/HmwsLib/TAA.glsl"

flat out float matID;
out	float ao;
out vec2 Texcoord;
out vec2 Imcoord;
out vec3 vColor;
flat out vec3 vTangent;
flat out vec3 vBitangent;
flat out vec3 vNormal;

void main()
{
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	DoTAAJitter(gl_Position);
    switch (int(mc_Entity.x)){	
		case 1 : matID = 26.0; break;	//stone
		case 2 : matID = 26.0; break;	//grass block
		case 4 : matID = 27.0; break;	//stonebrick
		case 10 : matID = 31.0; break;	//lava
		case 11 : matID = 31.0; break;	//lava
		case 12 : matID = 24.0; break;	//sand
		case 24 : matID = 25.0; break;	//sandstone	
		case -128 : matID = 25.0; break;		//sandstone
		case 35 : matID = 28.0; break;	//wool
		case 41 : matID = 20.0; break;	//gold block
		case 42 : matID = 21.0; break;	//iron block
		case 57 : matID = 22.0; break;	//diamond block
		case -123 : matID = 23.0; break;		//emerald block
		case 50 : matID = 30.0; break;	//torch
		case 51 : matID = 33.0; break;	//fire
		case 254 : matID = 34.0; break;	//soul_Fire_Torch
		case 59 : matID = 2.0;	//wheat
		case 31 : matID = 2.0; break;	//grass
		case 38 : matID = 2.0; break;	//rose
		case 37 : matID = 2.0; break;	//flowers
		case 1925 : matID = 2.0; break;	//Biomes O Plenty: Medium Grass
		case 1920 : matID = 2.0; break;	//Biomes O Plenty: Thorns, barley
		case 1921 : matID = 2.0; break;	//Biomes O Plenty: Sunflower	
		case 175 : matID = 2.0; break;	//tall flowers
		case 18 : matID = 3.0; break;	//leaves
		case 1962 : matID = 3.0; break;	//Biomes O Plenty: Leaves
		case 1924 : matID = 3.0; break;	//Biomes O Plenty: Leaves
		case 1923 : matID = 3.0; break;	//Biomes O Plenty: Leaves
		case 1926 : matID = 3.0; break;	//Biomes O Plenty: Leaves
		case 1936 : matID = 3.0; break;	//Biomes O Plenty: Giant Flower Leaves
		case 161 : matID = 3.0; break;	//Biomes O Plenty: Giant Flower Leaves
		case 89 : matID = 32.0; break;	//glowstone
		case 124 : matID = 32.0; break;	//lamp
		case 174 : matID = 57.0; break;	//packed_ice
		default : matID = 0.0; break;
	}
	ao = gl_Color.a;
    Texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    Imcoord = gl_MultiTexCoord1.xy / 255.0;
    vColor = gl_Color.rgb * (1.0 - float(int(matID) == 31) * 0.3);
	
    vTangent = normalize(gl_NormalMatrix * at_tangent.xyz);
    vNormal = normalize(gl_NormalMatrix * gl_Normal);
    vBitangent = cross(vTangent, vNormal);
}